void ProcessDialogEvent()
{
	ref NPChar, PChar, d;
	PChar = GetMainCharacter();
	aref Link, Diag;
	string NPC_Meeting;
	
	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makeref(d, Dialog);
	makearef(Diag, NPChar.Dialog);
	
	string iDay, iMonth, cargoid;
	iDay = environment.date.day;
	iMonth = environment.date.month;
	string lastspeak_date = iday + " " + iMonth;
	ref ctown = GetCurrentTown();
	
	switch(Dialog.CurrentNode)
	{
		//Fetch Quest -->
		case "fetch quest":
			d.Text = DLG_TEXT[1] + NPChar.fetch_quest.amount + " " + Goods[sti(NPChar.fetch_quest.good)].name + DLG_TEXT[2] + NPChar.fetch_quest.money + DLG_TEXT[3]  + NPChar.fetch_quest.expire;
			Link.l1 = DLG_TEXT[4];
			Link.l1.go = "agree fetch";
			Link.l2 = DLG_TEXT[5];
			Link.l2.go = "decline fetch";
		break;
		
		case "fetch quest complete":
			//succes
			d.Text = DLG_TEXT[13];
			Link.l1 = DLG_TEXT[7];
			Link.l1.go = "exit";
			//reward etc
			AddMoneyToCharacter(PChar,sti(NPChar.fetch_quest.money));
			ChangeCharacterReputation(PChar, 2);
			if(AUTO_SKILL_SYSTEM) { AddPartyExpChar(pchar, "Commerce", 100*makeint(PChar.rank)); }
			else { AddPartyExp(pchar, 100*makeint(PChar.rank)); }
			RemoveCharacterGoods(PChar,sti(NPChar.fetch_quest.good),sti(NPChar.fetch_quest.amount));
			//Levis Unlock Perk
			if(CheckPerkLocked("BasicCommerce")) UnlockPerk("BasicCommerce");
			//Clean up stuff
			//removeCargoFromIsland(Islands[sti(ctown.island)], NPChar.fetch_quest.cargoid); //For some stupid reason this doesnt work so have to do it manuall
			aref cargos; makearef(cargos,Islands[sti(ctown.island)].cargos);
			DeleteAttribute(cargos,NPChar.fetch_quest.cargoid);
			DeleteAttribute(NPChar,"fetch_quest");
			DeleteAttribute(NPChar,"fetch_quest_active");
			if(!CheckAttribute(PChar,"fetchquestcompleted")) PChar.fetchquestcompleted = 0;
			PChar.fetchquestcompleted = sti(PChar.fetchquestcompleted) + 1;
		break;
		
		case "fetch quests failed":
			//to late
			d.Text = DLG_TEXT[12];
			Link.l1 = DLG_TEXT[7];
			Link.l1.go = "exit";
			//Clean Up
			DeleteAttribute(NPChar,"fetch_quest");
			DeleteAttribute(NPChar,"fetch_quest_active");
			if(!CheckAttribute(PChar,"fetchquestfailed")) PChar.fetchquestfailed = 0;
			PChar.fetchquestfailed = sti(PChar.fetchquestfailed) + 1;
		break;
		
		case "decline fetch":
			Dialog.snd = "voice\ROMU\ROMU005";
			d.Text = DLG_TEXT[6] + NPChar.fetch_quest.expire;
			Link.l1 = DLG_TEXT[7];
			Link.l1.go = "exit";
		break;
		
		case "agree fetch":
			d.Text = DLG_TEXT[8];
			Link.l1 = DLG_TEXT[9];
			Link.l1.go = "exit";
			if(!CheckAttribute(PChar,"fetchquestactive")) PChar.fetchquestactive = 0;
			WriteNewLogEntry(("Helping the tailor of "+ctown.name), ("The tailor of "+ctown.name+" asked me to get "+NPChar.fetch_quest.amount+" "+ Goods[sti(NPChar.fetch_quest.good)].name +" from somewhere and deliver it back to him to get "+NPChar.fetch_quest.money+" gold coins. But I have to deliver it before "+NPChar.fetch_quest.expire+" or i will receive nothing."), "Personal", true);
			Logit("Ships Log Updated");
			AddMsgToCharacter(PChar,MSGICON_LOGBOOK);
			PlaySound("INTERFACE\notebook.wav");
			PChar.fetchquestactive = sti(PChar.fetchquestactive) +1;
			NPChar.fetch_quest_active = TRUE;
		break;
		
		case "First time":
			cargoid = getFetchQuestCargo("tailor",ctown);
			if(cargoid != "")
			{
				if(!CheckAttribute(NPChar,"fetch_quest_active"))
				{
					//There is a fetchquest cargo set for this character
					Link.l8 = DLG_TEXT[0];
					Link.l8.go = "fetch quest";
					if(!CheckAttribute(NPChar,"fetch_quest")) 
					{
						NPChar.fetch_quest.cargoid = cargoid;
						NPChar.fetch_quest.amount = getCargoAmount(Islands[sti(ctown.island)], cargoid);
						NPChar.fetch_quest.good = getCargoGood(Islands[sti(ctown.island)], cargoid);
						NPChar.fetch_quest.expire = getFetchQuestExpireDate(Islands[sti(ctown.island)], cargoid);
						NPChar.fetch_quest.money = getFetchQuestReward(sti(NPChar.fetch_quest.amount), sti(NPChar.fetch_quest.good), ctown);
						//SetCharacterGoods(PChar,sti(NPChar.fetch_quest.good),NPChar.fetch_quest.amount); //Debug Code
					}
				}
				else
				{
					int amount = GetCargoGoods(PChar, sti(NPChar.fetch_quest.good));
					for(int i=1; i<4; i++)
					{
						if(GetCompanionIndex(Pchar, i) != -1)
						{
							amount += GetCargoGoods(&Characters[getCompanionIndex(Pchar, i)], sti(NPChar.fetch_quest.good));
						}
					}
					if (amount >= sti(NPChar.fetch_quest.amount))
					{
						Link.l8 = DLG_TEXT[10];
						Link.l8.go = "fetch quest complete";
					}
				}
			}
			else
			{
				if(CheckAttribute(NPChar,"fetch_quest_active"))
				{
					Link.l8 = DLG_TEXT[11];
					Link.l8.go = "fetch quest failed";
				}
			}
		break;
		//Fetch Quest <--
	}
}